	parameter (nhbond = 5000 )
       DIMENSION AA(20),NUCL(9),XYZ1(3),XYZ2(3),xyzca(3),xyzc(3),
     1    XYZ3(3),XYZ4(3),XYZ5(3),XYZ6(3),XYZ7(3),XYZ8(3),
     2    XYZ9(3),XYZ10(3),XYZ11(3),XYZ12(3),XYZ13(3),xyzcm(3),
     3    XYZ17(3),XYZ18(3),XYZ19(3),XYZ20(3),XYZ21(3),XYZ22(3),
     4    DISPRO(10),ANGLE(10),xyzn(3),xyzcd(3),xyzcg(3),xyzcz(3),
     5    xyzne(3),bestang(10),bestdst(10),besttng(10),parp(5000,4),
     6    parb(5000,7),parr(5000,7),pprr(5000,7),pbx(10),pby(10),pbz(10)
	character*50 val1(10),valp,valv,filenm,cile,dile,gile
 	character*30 login,machine,date
       CHARACTER*3 AA,NAMEP,NAMED,RESP,RESD
       CHARACTER*3 NUCL
       CHARACTER*4 RESPH,pp(nhbond),pb(nhbond),rp(nhbond),pr(nhbond)
       character*4 dp, db
       CHARACTER*1 CHAINP,CHAIND,CHold                                        
       CHARACTER*80 LINE,OUTL
       CHARACTER*4 ATOM
       integer npp(nhbond,2),npb(nhbond,2),nrot(nhbond,2),nrop(nhbond,2) 
       integer pcnt,bcnt,rott,rotp,pcnd,bcnd,pro2pro
       COMMON /NAMES/NAMED(100000),RESD(100000),
     3          NAMEP(100000),RESP(100000)
       COMMON /DATA/XD(100000),YD(100000),ZD(100000),IRESD(100000),
     4          XP(100000),YP(100000),ZP(100000),IRESP(100000),NATD,NATP
       COMMON /CHAINS/CHAINP(100000),CHAIND(100000)
       COMMON /DNA/DIST_DNA(10),NU_DNA(10)
        COMMON /darr/darp(nhbond,4),darb(nhbond,7)
        COMMON /dchr/dp(nhbond),db(nhbond)
        COMMON /dnt/ndp(nhbond,2),ndb(nhbond,2)
        COMMON /cnt/pcnd,bcnd
        COMMON /dst/hbdst,hvdst,hbang,pro2pro,nchain
       DATA AA/'GLY','ALA','VAL','LEU','ILE','MET','PRO','PHE','TRP',
     1         'SER','THR','ASN','GLN','TYR','LYS','CYS','ARG','HIS',
     2         'ASP','GLU'/
       DATA NUCL/'DA ',' A ','DT ',' T ','DG ',' G ','DC ',' C ',' U '/ 
	
	k=0
	hbdst=3.0
	hbang=90.0
	hvdst=3.5
	pro2pro=0
	narg=iargc()
c	write(6,*) 'No of arguments received ',narg
        if(narg.eq.0)then
       	write(6,9999)
9999	format(/' Program pyrHBfind detects hydrogen bonds between protein and
     1 nucleic acid'/' residues by modelling hydrogen atom positions of
     2 amino groups considering'/' pyramidal geometry.  Extent of amino
     3 group non-planarity giving rise to'/' best hydrogen bond geometry
     4 is accepted.'//
     5 1x,'Sudipta Majumdar, Shayantani Mukherjee and Dhananjay Bhattach
     1aryya'/' Saha Institute of Nuclear Physics, Kolkata 700064, INDIA' 
     2/' E-mail: dhananjay.bhattacharyya@saha.ac.in'//
     3 ' Version 1.0 released on 17.2.2005.'/
     4 ' ----------------------------------'//
     5 '[USAGE]: pyrHBfind [-flags] filename'/ 'Flags [optional]:'//
     6' -HB [real]   Upper cut-off distance between modelled hydrogen at
     1om and'/14x,'hydrogen bond acceptor [DEFAULT = 3.0]'//
     2' -HA [real]   Lower cut-off angle between HB donor, modelled hydr 
     1ogen'/14x,'atom and HB acceptor [DEFAULT = 90.0]'//
     3 ' -NH [real]   Upper cut-off distance between HB donor (non-hydro
     1gen)'/14x,'and HB acceptor [DEFAULT = 3.5]'/' -PP [bool] Whether
     4 protein-protein interaction is requested')
	       stop
        endif
	do i=1,narg
	  call getarg(i,val1(i))
	end do
	do i=1,narg
	  if(val1(i)(1:1).eq.'-') then
	    valp=val1(i)(2:20)
	    valv=val1(i+1)
	    if(valp.eq.'HB'.or.valp.eq.'hb'.or.valp.eq.'Hb'.or.valp.
     1       eq.'hB')then
	       read(valv,*) hbdst
	    else if(valp.eq.'HA'.or.valp.eq.'ha'.or.valp.eq.'Ha'.or.valp.
     1       eq.'hA')then
	       read(valv,*) hbang
	    else if(valp.eq.'NH'.or.valp.eq.'nh'.or.valp.eq.'Nh'.or.valp.
     1       eq.'nH')then
	       read(valv,*) hvdst
	    else if(valp.eq.'PP'.or.valp.eq.'pp'.or.valp.eq.'Pp'.or.valp.
     1       eq.'pP') then
	       pro2pro=1
	    else
       	write(6,9999)
	       stop
	    endif
          else if(i.gt.1) then
	    if(val1(i-1)(1:1).ne.'-') then
              filenm=val1(i)
	    endif
	  else
	    filenm=val1(i)
          endif
	enddo
 	write(6,9998) hbdst,hbang,hvdst,filenm
9998	format(1x,'HB dist',F5.2,' HB angle',f7.2,' Heavy Atom Dist'
     1 ,f5.2,' Input File ',a50)
1	format(f10.2)	
        call getlog(login)
        call hostnm(machine)
        call fdate(date)
        nn=index(filenm,'.')
        cile=filenm(1:nn-1)//'_HB.pdb' 
        dile=filenm(1:nn-1)//'_HB.out' 
        gile=filenm(1:nn-1)//'_inp.pdb' 
	OPEN(UNIT=1,FILE=filenm,STATUS='OLD',ERR=199)
        OPEN(UNIT=7,FILE=cile)
        OPEN(UNIT=17,FILE=dile)
c        OPEN(UNIT=10,FILE=gile)
        write(17,30001)filenm(1:(index(filenm,' ')))
30001	format(1x,'Calculation done for PDB-ID: ',a)
        write(17,30002)login(1:(index(login,' '))),machine(1:index
     1 (machine,' '))
	write(17,30003) date
30002	format(1x,'by user: ',a,' on Computer: ',a)
30003	format(40x,a)
c        write(17,*)'on machine: ',machine,' Date: ',date  
        write(17,*)'=================================================='
        write(17,*)' '
	L=1
	K=1
	CHold=' '
	nchain=0
        DO 5 N=1,100000
          READ(1,6,END=99)LINE
          DO 7 I=1,20
            IF(LINE(1:4).EQ.'ATOM')THEN
              IF(LINE(18:20).EQ.AA(I))THEN
               if(line(27:27).eq.' ')then
               READ(LINE,3) RESP(K),NAMEP(K),CHAINP(K),IRESP(K),
     1                      XP(K),YP(K),ZP(K)
	       if(chainp(k).ne.CHold) then
	         nchain=nchain+1
	         CHold=chainp(k)
	       endif
c              WRITE(6,3) RESP(K),NAMEP(K),CHAINP(K),IRESP(K),
c    1                      XP(K),YP(K),ZP(K)
                K=K+1
               endif
	      END IF
            END IF 
7        CONTINUE
         DO 8 J=1,9
           IF(LINE(1:4).eq.'ATOM')THEN
             IF(LINE(19:21).EQ.NUCL(J))THEN
               if(line(27:27).eq.' ')then
              READ(LINE,4) RESD(L),NAMED(L),CHAIND(L),IRESD(L),
     3                     XD(L),YD(L),ZD(L)
c              WRITE(10,4) RESD(L),NAMED(L),CHAIND(L),IRESD(L),
c     3                     XD(L),YD(L),ZD(L)
3        FORMAT('ATOM',9x,A3,1X,A3,1X,A1,I4,4X,3F8.3)
c333      FORMAT('ATOM',9x,A3,1X,A3,1X,A1,I4,4X,3F8.3)
4        FORMAT('ATOM',9x,A3,2X,A3,A1,1X,I4,3X,3F8.3)
c444      FORMAT('ATOM',9x,A3,2X,A3,A1,I4,4X,3F8.3)
                L=L+1
               endif
	      END IF
            END IF
8        CONTINUE
5      CONTINUE
99     CONTINUE
	close (unit=1)
	close(unit=2)
	close(unit=3)
	NATD = L-1
	NATP = K-1
6      FORMAT(A80)
       pcnt=0  
       bcnt=0
         pcnd=0
         bcnd=0
       rott=0
       rotp=0
	DO I=1,NATP
          IF(NAMEP(I).EQ.'ASN')THEN
            IF(pro2pro.eq.0.and.RESP(I).EQ.'OD1')THEN
              CALL DISTCAL(I,JNA)
            END IF
            IF(RESP(I).EQ.'ND2')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NND2 = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	          IF(RESP(LL).EQ.'CG '.AND.IRESP(LL).EQ.NRP) NCG = LL
	          IF(RESP(LL).EQ.'CB '.AND.IRESP(LL).EQ.NRP) NCB = LL
	      END DO
              BL=1.0 
	      BANG=120.0 
              RESPH='HD21'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=-30,30,2
                CALL FIXATM(NCB,NCG,NND2,BANG,TANG,BL,XYZ1,0)
                CALL ANGDISPRO(JNA,XYZ1,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz1,bestang,
     1                        bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
                do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                    endif
                   end if
                 end do
              END DO
	      do kk=1,jna
             if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
                endif
	      enddo
              RESPH='HD22'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=150,210,2 
              CALL FIXATM(NCB,NCG,NND2,BANG,TANG,BL,XYZ17,0)
              CALL ANGDISPRO(JNA,XYZ17,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz17,bestang,
     1                          bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.180.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO 
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
10     FORMAT('ATOM',8X,A4,1X,A3,1X,A1,1X,I4,3X,3f8.3)
12     FORMAT(f8.3,3x,A4,1X,A4,1X,A3,1X,A1,1X,I4,2X,A4,1X,A3,1X,A1,
     1        1x,i4,2x,F8.3,2X,F10.3,2X,F5.1) 
             END IF        
	    END IF
          ELSE IF(NAMEP(I).EQ.'SER')THEN
           IF(RESP(I).EQ.'OG ')THEN
               CALL DISTCAL(I,JNA)  
              IF(JNA.GE.1)THEN
	       NOG = I
	       NRP = IRESP(I)
	       DO LL=I-20,I+20
	       IF(RESP(LL).EQ.'CB '.AND.IRESP(LL).EQ.NRP) NCB = LL
	       IF(RESP(LL).EQ.'CA '.AND.IRESP(LL).EQ.NRP) NCA = LL
	       END DO
                BL=0.96
	        BANG=106.0 
                RESPH=' HG1'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
                DO TANG=0,360,2
                CALL FIXATM(NCA,NCB,NOG,BANG,TANG,BL,XYZ2,0)
               CALL ANGDISPRO(JNA,XYZ2,I,0.96,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz2,bestang,
     1                     bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
              rotp=rotp+1
              pprr(rotp,1)=dist_dna(kk) 
              pprr(rotp,2)=dispro(kk) 
              pprr(rotp,3)=angle(kk) 
              pprr(rotp,4)=tang 
              pr(rotp)=resph
              nrop(rotp,1)=i
              nrop(rotp,2)=nu_dna(kk)
                     endif
                  end if
              end do
               END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              rott=rott+1
              parr(rott,1)=dist_dna(kk) 
              parr(rott,2)=bestdst(kk) 
              parr(rott,3)=bestang(kk) 
              parr(rott,4)=besttng(kk) 
              parr(rott,5)=pbx(kk)  
              parr(rott,6)=pby(kk)  
              parr(rott,7)=pbz(kk)  
              rp(rott)=resph
              nrot(rott,1)=i
              nrot(rott,2)=nu_dna(kk)
              endif
              end do
               END IF
           END IF
9               FORMAT(A4,3F10.5,3X,A3)
          ELSE IF(NAMEP(I).EQ.'THR')THEN
           IF(RESP(I).EQ.'OG1')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NOG1 = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CB '.AND.IRESP(LL).EQ.NRP) NCB = LL
	      IF(RESP(LL).EQ.'CA '.AND.IRESP(LL).EQ.NRP) NCA = LL
	      END DO
              BL=0.96
	      BANG=106.0 
              RESPH=' HG1'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=0,360,2
              CALL FIXATM(NCA,NCB,NOG1,BANG,TANG,BL,XYZ3,0)
              CALL ANGDISPRO(JNA,XYZ3,I,0.96,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz3,bestang,
     1                     bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
              rotp=rotp+1
              pprr(rotp,1)=dist_dna(kk) 
              pprr(rotp,2)=dispro(kk) 
              pprr(rotp,3)=angle(kk) 
              pprr(rotp,4)=tang 
              pr(rotp)=resph
              nrop(rotp,1)=i
              nrop(rotp,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              rott=rott+1
              parr(rott,1)=dist_dna(kk) 
              parr(rott,2)=bestdst(kk) 
              parr(rott,3)=bestang(kk) 
              parr(rott,4)=besttng(kk) 
              parr(rott,5)=pbx(kk)  
              parr(rott,6)=pby(kk)  
              parr(rott,7)=pbz(kk)  
              rp(rott)=resph
              nrot(rott,1)=i
              nrot(rott,2)=nu_dna(kk)
              endif
              end do
             END IF
           END IF
          ELSE IF(NAMEP(I).EQ.'GLN')THEN
              IF(pro2pro.eq.0.and.RESP(I).EQ.'OE1')THEN
              CALL DISTCAL(I,JNA)
              END IF
            IF(RESP(I).EQ.'NE2')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NNE2 = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CD '.AND.IRESP(LL).EQ.NRP) NCD = LL
	      IF(RESP(LL).EQ.'CG '.AND.IRESP(LL).EQ.NRP) NCG = LL
	      END DO
              BL=1.0 
	      BANG=120.0 
              RESPH='HE21'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=-30,30,2
              CALL FIXATM(NCG,NCD,NNE2,BANG,TANG,BL,XYZ4,0)
              CALL ANGDISPRO(JNA,XYZ4,I,1.0,DISPRO,ANGLE) 
		call bestfind(angle,dispro,jna,xyz4,bestang,
     1                      bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
              RESPH='HE22'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=150,210,2
              CALL FIXATM(NCG,NCD,NNE2,BANG,TANG,BL,XYZ18,0)
              CALL ANGDISPRO(JNA,XYZ18,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz18,bestang,
     1                     bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.180.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
             END IF
            END IF
          ELSE IF(NAMEP(I).EQ.'TYR')THEN
            IF(RESP(I).EQ.'OH ')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NOH = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CZ '.AND.IRESP(LL).EQ.NRP) NCZ = LL
	      IF(RESP(LL).EQ.'CE1'.AND.IRESP(LL).EQ.NRP) NCE1 = LL
	      END DO
              BL=0.96
              RESPH=' HH '
	      BANG=106.0 
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
	      DO TANG=0,360,2
              CALL FIXATM(NCE1,NCZ,NOH,BANG,TANG,BL,XYZ5,0)
              CALL ANGDISPRO(JNA,XYZ5,I,0.96,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz5,bestang,
     1                    bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
              rotp=rotp+1
              pprr(rotp,1)=dist_dna(kk) 
              pprr(rotp,2)=dispro(kk) 
              pprr(rotp,3)=angle(kk) 
              pprr(rotp,4)=tang 
              pr(rotp)=resph
              nrop(rotp,1)=i
              nrop(rotp,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              rott=rott+1
              parr(rott,1)=dist_dna(kk) 
              parr(rott,2)=bestdst(kk) 
              parr(rott,3)=bestang(kk) 
              parr(rott,4)=besttng(kk) 
              parr(rott,5)=pbx(kk)  
              parr(rott,6)=pby(kk)  
              parr(rott,7)=pbz(kk)  
              rp(rott)=resph
              nrot(rott,1)=i
              nrot(rott,2)=nu_dna(kk)
              endif
              end do
             END IF
            END IF
          ELSE IF(NAMEP(I).EQ.'CYS')THEN
            IF(RESP(I).EQ.'SG ')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NSG = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'cb '.AND.IRESP(LL).EQ.NRP) NCB = LL
	      IF(RESP(LL).EQ.'ca '.AND.IRESP(LL).EQ.NRP) NCA = LL
	      END DO
              BL=1.325 
	      BANG= 95.0 
              RESPH=' HG1'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=0,360,2
              CALL FIXATM(NCA,NCB,NSG,BANG,TANG,BL,XYZ6,0)
              CALL ANGDISPRO(JNA,XYZ6,I,1.325,DISPRO,ANGLE) 
		call bestfind(angle,dispro,jna,xyz6,bestang,
     1                    bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
              rotp=rotp+1
              pprr(rotp,1)=dist_dna(kk) 
              pprr(rotp,2)=dispro(kk) 
              pprr(rotp,3)=angle(kk) 
              pprr(rotp,4)=tang 
              pr(rotp)=resph
              nrop(rotp,1)=i
              nrop(rotp,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              rott=rott+1
              parr(rott,1)=dist_dna(kk) 
              parr(rott,2)=bestdst(kk) 
              parr(rott,3)=bestang(kk) 
              parr(rott,4)=besttng(kk) 
              parr(rott,5)=pbx(kk)  
              parr(rott,6)=pby(kk)  
              parr(rott,7)=pbz(kk)  
              rp(rott)=resph
              nrot(rott,1)=i
              nrot(rott,2)=nu_dna(kk)
              endif
              end do
             END IF      
            END IF
          ELSE IF(NAMEP(I).EQ.'LYS')THEN
            IF(RESP(I).EQ.'NZ ')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NNZ = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CE '.AND.IRESP(LL).EQ.NRP) NCE = LL
	      IF(RESP(LL).EQ.'CD '.AND.IRESP(LL).EQ.NRP) NCD = LL
	      END DO
              BL=1.0 
	      BANG=120.0 
              RESPH=' HZ1'
                do kk=1,jna     
     	        bestang(kk)=0.0
                end do
              DO TANG=0,360,2
              CALL FIXATM(NCD,NCE,NNZ,BANG,TANG,BL,XYZ7,0)
              CALL ANGDISPRO(JNA,XYZ7,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz7,bestang,
     1                    bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
              rotp=rotp+1
              pprr(rotp,1)=dist_dna(kk) 
              pprr(rotp,2)=dispro(kk) 
              pprr(rotp,3)=angle(kk) 
              pprr(rotp,4)=tang 
              pr(rotp)=resph
              nrop(rotp,1)=i
              nrop(rotp,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO 
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              rott=rott+1
              parr(rott,1)=dist_dna(kk) 
              parr(rott,2)=bestdst(kk) 
              parr(rott,3)=bestang(kk) 
              parr(rott,4)=besttng(kk) 
              parr(rott,5)=pbx(kk)  
              parr(rott,6)=pby(kk)  
              parr(rott,7)=pbz(kk)  
              rp(rott)=resph
              nrot(rott,1)=i
              nrot(rott,2)=nu_dna(kk)
              endif
              end do
             END IF      
            END IF
          ELSE IF(NAMEP(I).EQ.'ARG')THEN
            IF(RESP(I).EQ.'NH1')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NNH1 = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CZ '.AND.IRESP(LL).EQ.NRP) NCZ = LL
	      IF(RESP(LL).EQ.'NE '.AND.IRESP(LL).EQ.NRP) NNE = LL
	      END DO
              BL=1.0 
	      BANG=120.0 
              RESPH='HH11'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=-30,30,2
              CALL FIXATM(NNE,NCZ,NNH1,BANG,TANG,BL,XYZ8,0)
              CALL ANGDISPRO(JNA,XYZ8,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz8,bestang,
     1                      bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO  
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
              RESPH='HH12'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=150,210,2
              CALL FIXATM(NNE,NCZ,NNH1,BANG,TANG,BL,XYZ19,0)
              CALL ANGDISPRO(JNA,XYZ19,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz19,bestang,
     1                         bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.180.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO	 
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
	    END IF
	   END IF
           IF(RESP(I).EQ.'NH2')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
	      NNH2 = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CZ '.AND.IRESP(LL).EQ.NRP) NCZ = LL
	      IF(RESP(LL).EQ.'NE '.AND.IRESP(LL).EQ.NRP) NNE = LL
	      END DO
              BL=1.0 
	      BANG=120.0
              RESPH='HH21'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=-30,30,2 
              CALL FIXATM(NNE,NCZ,NNH2,BANG,TANG,BL,XYZ20,0)
              CALL ANGDISPRO(JNA,XYZ20,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz20,bestang,
     1                     bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.0.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
              RESPH='HH22'
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=150,210,2 
              CALL FIXATM(NNE,NCZ,NNH2,BANG,TANG,BL,XYZ21,0)
              CALL ANGDISPRO(JNA,XYZ21,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz21,bestang,
     1                     bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.180.0)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
             END IF
            END IF         
     	    IF( RESP(I).EQ.'NE ')THEN
              CALL DISTCAL(I,JNA)
             IF(JNA.GE.1)THEN
              NNE = I
	      NRP = IRESP(I)
	      DO LL=I-20,I+20
	      IF(RESP(LL).EQ.'CD '.AND.IRESP(LL).EQ.NRP) NCD = LL
	      IF(RESP(LL).EQ.'CG '.AND.IRESP(LL).EQ.NRP) NCG = LL
              if(resp(ll).eq.'CZ '.and.iresp(ll).eq.nrp) ncz=ll
	      END DO
	      xyzcd(1)=xp(ncd)
	      xyzcd(2)=yp(ncd)
	      xyzcd(3)=zp(ncd)
	      xyzcg(1)=xp(ncg)
	      xyzcg(2)=yp(ncg)
	      xyzcg(3)=zp(ncg)
	      xyzcz(1)=xp(ncz)
	      xyzcz(2)=yp(ncz)
	      xyzcz(3)=zp(ncz)
	      xyzne(1)=xp(nne)
	      xyzne(2)=yp(nne)
	      xyzne(3)=zp(nne)
	      call toran(xyzcz,xyzne,xyzcd,xyzcg,value)
c              call toran(xyzcd,xyzcg,xyzne,xyzcz,value)
	      val=value+180.0
              BL=1.0 
	      BANG=120.0 
              RESPH=' HE '
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=val-30,val+30,2	
              CALL FIXATM(NCG,NCD,NNE,BANG,TANG,BL,XYZ9,0)
              CALL ANGDISPRO(JNA,XYZ9,I,1.0,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz9,bestang,
     1                     bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.val)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
             END IF
            END IF
           ELSE IF(NAMEP(I).EQ.'HIS')THEN
            IF(RESP(I).EQ.'ND1')THEN
              CALL DISTCAL(I,JNA)
            IF(JNA.GE.1)THEN
      NND1 = I
      NRP = IRESP(I)
      DO LL=I-20,I+20
      IF(RESP(LL).EQ.'CG '.AND.IRESP(LL).EQ.NRP) NCG = LL
      IF(RESP(LL).EQ.'CB '.AND.IRESP(LL).EQ.NRP) NCB = LL
      END DO
             BL=1.0 
      RESPH=' HD1'
      BANG=126.0 
      do kk=1,jna
    	        bestang(kk)=0.0
      enddo
      DO TANG=-10,10,2
             CALL FIXATM(NCB,NCG,NND1,BANG,TANG,BL,XYZ10,0)
             CALL ANGDISPRO(JNA,XYZ10,I,1.0,DISPRO,ANGLE)
	call bestfind(angle,dispro,jna,xyz10,bestang,bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
             do kk=1,jna
                 if (tang.eq.0.0)then
                   if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                     pcnt=pcnt+1
                     parp(pcnt,1)=dist_dna(kk) 
                     parp(pcnt,2)=dispro(kk) 
                     parp(pcnt,3)=angle(kk) 
                     parp(pcnt,4)=tang 
                     pp(pcnt)=resph
                     npp(pcnt,1)=i
                     npp(pcnt,2)=nu_dna(kk)
                     endif
                 end if
             end do
             END DO
            do kk=1,jna
             if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
             bcnt=bcnt+1
             parb(bcnt,1)=dist_dna(kk) 
             parb(bcnt,2)=bestdst(kk) 
             parb(bcnt,3)=bestang(kk) 
             parb(bcnt,4)=besttng(kk) 
             parb(bcnt,5)=pbx(kk)  
             parb(bcnt,6)=pby(kk)  
             parb(bcnt,7)=pbz(kk)  
             pb(bcnt)=resph
             npb(bcnt,1)=i
             npb(bcnt,2)=nu_dna(kk)
             endif
             end do
            END IF 
            END IF      
            IF(RESP(I).EQ.'NE2')THEN
              CALL DISTCAL(I,JNA)
            IF(JNA.GE.1)THEN
      NNE2 = i
      NRP = IRESP(I)
      DO LL=I-20,I+20
      IF(RESP(LL).EQ.'CD2'.AND.IRESP(LL).EQ.NRP) NCD2 = LL
      IF(RESP(LL).EQ.'CG '.AND.IRESP(LL).EQ.NRP) NCG = LL
      END DO
             BL=1.0 
      RESPH=' HE2'
      BANG=120.0 
      do kk=1,jna
    	        bestang(kk)=0.0
      enddo
      DO TANG=170,190,2
             CALL FIXATM(NCG,NCD2,NNE2,BANG,TANG,BL,XYZ11,0)
             CALL ANGDISPRO(JNA,XYZ11,I,1.0,DISPRO,ANGLE)
	call bestfind(angle,dispro,jna,xyz11,bestang,bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
             do kk=1,jna
                 if (tang.eq.180.0)then
                   if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                     pcnt=pcnt+1
                     parp(pcnt,1)=dist_dna(kk) 
                     parp(pcnt,2)=dispro(kk) 
                     parp(pcnt,3)=angle(kk) 
                     parp(pcnt,4)=tang 
                     pp(pcnt)=resph
                     npp(pcnt,1)=i
                     npp(pcnt,2)=nu_dna(kk)
                    endif
                 end if
             end do
             END DO
            do kk=1,jna
             if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
             bcnt=bcnt+1
             parb(bcnt,1)=dist_dna(kk) 
             parb(bcnt,2)=bestdst(kk) 
             parb(bcnt,3)=bestang(kk) 
             parb(bcnt,4)=besttng(kk) 
             parb(bcnt,5)=pbx(kk)  
             parb(bcnt,6)=pby(kk)  
             parb(bcnt,7)=pbz(kk)  
             pb(bcnt)=resph
             npb(bcnt,1)=i
             npb(bcnt,2)=nu_dna(kk)
             endif
             end do
            END IF      
            END IF
            ELSE IF(NAMEP(I).EQ.'ASP')THEN
              IF(pro2pro.eq.0.and.(RESP(I).EQ.'OD1'.OR.RESP(I).EQ.
     1           'OD2'))THEN
              CALL DISTCAL(I,JNA)
              END IF
            ELSE IF(NAMEP(I).EQ.'GLU')THEN
              IF(pro2pro.eq.0.and.(RESP(I).EQ.'OE1'.OR.RESP(I).EQ.
     1           'OE2'))THEN
              CALL DISTCAL(I,JNA)
              END IF
          ELSE IF(NAMEP(I).EQ.'TRP')THEN
            IF(RESP(I).EQ.'NE1')THEN
              CALL DISTCAL(I,JNA)
            IF(JNA.GE.1)THEN
             NNE1 = I
             NRP = IRESP(I)
             DO LL=I-20,I+20
               IF(RESP(LL).EQ.'CD1'.AND.IRESP(LL).EQ.NRP) NCD1 = LL
               IF(RESP(LL).EQ.'CG'.AND.IRESP(LL).EQ.NRP) NCG = LL
             END DO
             BL=0.9760 
             RESPH=' HE1'
             BANG=126.0 
             do kk=1,jna
    	        bestang(kk)=0.0
             enddo
             DO TANG=150,210,2
             CALL FIXATM(NCG,NCD1,NNE1,BANG,TANG,BL,XYZ12,0)
             CALL ANGDISPRO(JNA,XYZ12,I,0.9760,DISPRO,ANGLE) 
	call bestfind(angle,dispro,jna,xyz122,bestang,bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
             do kk=1,jna
                 if (tang.eq.180.0)then
                   if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                     pcnt=pcnt+1
                     parp(pcnt,1)=dist_dna(kk) 
                     parp(pcnt,2)=dispro(kk) 
                     parp(pcnt,3)=angle(kk) 
                     parp(pcnt,4)=tang 
                     pp(pcnt)=resph
                     npp(pcnt,1)=i
                     npp(pcnt,2)=nu_dna(kk)
                    endif
                 end if
             end do
             END DO 
            do kk=1,jna
             if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
             bcnt=bcnt+1
             parb(bcnt,1)=dist_dna(kk) 
             parb(bcnt,2)=bestdst(kk) 
             parb(bcnt,3)=bestang(kk) 
             parb(bcnt,4)=besttng(kk) 
             parb(bcnt,5)=pbx(kk)  
             parb(bcnt,6)=pby(kk)  
             parb(bcnt,7)=pbz(kk)  
             pb(bcnt)=resph
             npb(bcnt,1)=i
             npb(bcnt,2)=nu_dna(kk)
             endif
             end do 
            END IF
            END IF
	    endif
           IF(RESP(I).EQ.'N  '.AND.NAMEP(I).NE.'PRO')THEN
              CALL DISTCAL(I,JNA)      
             IF(JNA.GE.1)THEN
	      NN  = I
	      NRP = IRESP(I)
	      DO LL=I-40,I+40
	      IF(RESP(LL).EQ.'CA'.AND.IRESP(LL).EQ.NRP) NCA = LL
	      IF(RESP(LL).EQ.'C '.AND.IRESP(LL).EQ.NRP) NC  = LL
	      if(resp(ll).eq.'C '.and.iresp(ll).eq.nrp-1) ncm=ll
	      END DO
	      xyzca(1)=xp(nca)
	      xyzca(2)=yp(nca)
	      xyzca(3)=zp(nca)
	      xyzc(1)=xp(nc)
	      xyzc(2)=yp(nc)
	      xyzc(3)=zp(nc)
	      xyzcm(1)=xp(ncm)
	      xyzcm(2)=yp(ncm)
	      xyzcm(3)=zp(ncm)
	      xyzn(1)=xp(nn)
	      xyzn(2)=yp(nn)
	      xyzn(3)=zp(nn)
	      call toran(xyzcm,xyzn,xyzca,xyzc,value)
	      val=value+180.0
              BL=0.9970 
	      BANG=117.0 
              RESPH=' HN '
	      do kk=1,jna
     	        bestang(kk)=0.0
	      enddo
              DO TANG=val-30,val+30,2
              CALL FIXATM(NC,NCA,NN,BANG,TANG,BL,XYZ13,0)
              CALL ANGDISPRO(JNA,XYZ13,I,0.9970,DISPRO,ANGLE)
		call bestfind(angle,dispro,jna,xyz13,bestang,
     1                      bestdst,besttng
     1                        ,tang,pbx,pby,pbz)
              do kk=1,jna
                  if (tang.eq.val)then
                    if((dispro(kk).le.hbdst).and.(dispro(kk).ge.1.6)
     1                  .and.(angle(kk).gt.hbang))then
                      pcnt=pcnt+1
                      parp(pcnt,1)=dist_dna(kk) 
                      parp(pcnt,2)=dispro(kk) 
                      parp(pcnt,3)=angle(kk) 
                      parp(pcnt,4)=tang 
                      pp(pcnt)=resph
                      npp(pcnt,1)=i
                      npp(pcnt,2)=nu_dna(kk)
                     endif 
                  end if
              end do
              END DO
	      do kk=1,jna
              if((bestdst(kk).le.hbdst).and.(bestang(kk).gt.hbang))then
              bcnt=bcnt+1
              parb(bcnt,1)=dist_dna(kk) 
              parb(bcnt,2)=bestdst(kk) 
              parb(bcnt,3)=bestang(kk) 
              parb(bcnt,4)=besttng(kk) 
              parb(bcnt,5)=pbx(kk)  
              parb(bcnt,6)=pby(kk)  
              parb(bcnt,7)=pbz(kk)  
              pb(bcnt)=resph
              npb(bcnt,1)=i
              npb(bcnt,2)=nu_dna(kk)
              endif
              end do
	     END IF
	   endif
           IF(pro2pro.eq.0.and.RESP(I).EQ.'O  ')THEN
              CALL DISTCAL(I,JNA)
           END IF
	END DO    
c ----------writing out file-----------------------------------------
        write(17,*)'Hydrogen bonds with planar amino groups of protein'
        write(17,*)' '
        do n=1,pcnt
	 if(pro2pro.eq.0) then
          write(17,12)parp(n,1),pp(n),resp(npp(n,1)),namep(npp(n,1)),
     1              chainp(npp(n,1)),iresp(npp(n,1)),resd(npp(n,2)),
     1              named(npp(n,2)),chaind(npp(n,2)),
     1           iresd(npp(n,2)),parp(n,2),parp(n,3),parp(n,4)
	 else
          write(17,12)parp(n,1),pp(n),resp(npp(n,1)),namep(npp(n,1)),
     1              chainp(npp(n,1)),iresp(npp(n,1)),resp(npp(n,2)),
     1              namep(npp(n,2)),chainp(npp(n,2)),
     1           iresp(npp(n,2)),parp(n,2),parp(n,3),parp(n,4)
	 endif
        end do
       write(17,*)'No of HB with planar amino groups of protein is',pcnt
       write(6,*)'No of HB with planar amino groups of protein is',pcnt
        write(17,*)'==================================================='
c       write(17,*)' '
c       write(17,*)'Hydrogen bonds with planar OH groups of protein'
c       write(17,*)' '
c       do n=1,rotp
c        write(17,12)pprr(n,1),pr(n),resp(nrop(n,1)),namep(nrop(n,1)),
c    1            chainp(nrop(n,1)),iresp(nrop(n,1)),resd(nrop(n,2)),
c    1            named(nrop(n,2)),chaind(nrop(n,2)),
c    1           iresd(nrop(n,2)),pprr(n,2),pprr(n,3),pprr(n,4)
c       end do
c       write(17,*)'No of HB with planar OH groups of protein is',rotp
c       write(17,*)'==================================================='
        write(17,*)' '
        write(17,*)'Hydrogen bonds with planar amino groups of DNA'
        write(17,*)' '
        do n=1,pcnd
          write(17,12)darp(n,1),dp(n),resd(ndp(n,1)),named(ndp(n,1)),
     1              chaind(ndp(n,1)),iresd(ndp(n,1)),resp(ndp(n,2)),
     1              namep(ndp(n,2)),chainp(ndp(n,2)),
     1           iresp(ndp(n,2)),darp(n,2),darp(n,3),darp(n,4)
        end do
        write(17,*)'No of HB with planar amino groups of DNA is',pcnd
        write(6,*)'No of HB with planar amino groups of DNA is',pcnd
        write(17,*)'==================================================='
        write(17,*)' '
      write(17,*)'Hydrogen bonds with nonplanar amino groups of protein'
        write(17,*)' '
        do n=1,bcnt
	 if(pro2pro.eq.0) then
          write(17,12)parb(n,1),pb(n),resp(npb(n,1)),namep(npb(n,1)),
     1              chainp(npb(n,1)),iresp(npb(n,1)),resd(npb(n,2)),
     1              named(npb(n,2)),chaind(npb(n,2)),
     1           iresd(npb(n,2)),parb(n,2),parb(n,3),parb(n,4)
	 else
          write(17,12)parb(n,1),pb(n),resp(npb(n,1)),namep(npb(n,1)),
     1              chainp(npb(n,1)),iresp(npb(n,1)),resp(npb(n,2)),
     1              namep(npb(n,2)),chainp(npb(n,2)),
     1           iresp(npb(n,2)),parb(n,2),parb(n,3),parb(n,4)
	 endif
        end do
      write(17,*)'No of HB with nonplanar amino groups of protein is',
     1                        bcnt
      write(6,*)'No of HB with nonplanar amino groups of protein is',
     1                        bcnt
        write(17,*)'==================================================='
        write(17,*)' '
        write(17,*)'Hydrogen bonds with nonplanar amino groups of DNA'
        do n=1,bcnd
          write(17,12)darb(n,1),db(n),resd(ndb(n,1)),named(ndb(n,1)),
     1              chaind(ndb(n,1)),iresd(ndb(n,1)),resp(ndb(n,2)),
     1              namep(ndb(n,2)),chainp(ndb(n,2)),
     1           iresp(ndb(n,2)),darb(n,2),darb(n,3),darb(n,4)
        end do
      write(17,*)'No of HB with nonplanar amino groups of DNA is',bcnd
      write(6,*)'No of HB with nonplanar amino groups of DNA is',bcnd
        write(17,*)'==================================================='
        write(17,*)' '
        write(17,30010)
30010	format(1x,'Hydrogen bonds with rotatable OH or NH3(+) groups of 
     1protein')
        write(17,*)' '
        do n=1,rott
	  if(pro2pro.eq.0) then
	   write(17,12)parr(n,1),rp(n),resp(nrot(n,1)),namep(nrot(n,1)),
     1            chainp(nrot(n,1)),iresp(nrot(n,1)),resd(nrot(n,2)),
     1            named(nrot(n,2)),chaind(nrot(n,2)),
     1           iresd(nrot(n,2)),parr(n,2),parr(n,3),parr(n,4)
	  else
	   write(17,12)parr(n,1),rp(n),resp(nrot(n,1)),namep(nrot(n,1)),
     1            chainp(nrot(n,1)),iresp(nrot(n,1)),resp(nrot(n,2)),
     1            namep(nrot(n,2)),chainp(nrot(n,2)),
     1           iresp(nrot(n,2)),parr(n,2),parr(n,3),parr(n,4)
	  endif
        end do
       write(17,30011)rott
       write(6,30011)rott
30011  format(1x,'No of HB with rotatable OH or NH3(+) groups of protein
     1 is',i4)
        write(17,*)'==================================================='
c-------------writing PDB of all atoms----------------------------------
        mm=0
        do n=1,natp
           do i=1,bcnt
              if(npb(i,1).eq.n)then
                mm=mm+1
                WRITE(7,30000) mm,pb(i),NAMEP(n),CHAINP(n),iresp(n),
     1                   parb(i,5),parb(i,6),parb(i,7) 
              endif
            end do
           do i=1,rott
              if(nrot(i,1).eq.n)then
                mm=mm+1
                WRITE(7,30000) mm,rp(i),NAMEP(n),CHAINP(n),iresp(n),
     1                   parr(i,5),parr(i,6),parr(i,7) 
              endif
            end do
                 mm=mm+1
                 WRITE(7,3000) mm,RESP(n),NAMEP(n),CHAINP(n),iresp(n),
     1                    XP(n),YP(n),ZP(n)
        end do
        nn=mm
        do n=1,natd
           do i=1,bcnd
              if(ndb(i,1).eq.n)then
                nn=nn+1
                WRITE(7,30000) nn,db(i),NAMED(n),CHAIND(n),iresd(n),
     1                   darb(i,5),darb(i,6),darb(i,7) 
              endif
            end do
                 nn=nn+1
                 WRITE(7,3000) nn,RESD(n),NAMED(n),CHAIND(n),iresd(n),
     1                    XD(n),YD(n),ZD(n)
        end do
30000   FORMAT('HETATM',i5,1x,A4,1X,A3,1X,A1,I4,4X,3F8.3)
3000    FORMAT('ATOM',2x,i5,2x,A3,1X,A3,1X,A1,I4,4X,3F8.3)
	write(*,*) 'No of chains present in the file',nchain
        STOP
199	CONTINUE
	WRITE(*,*) 'UNABLE TO OPEN THE DESIRED FILE'
	STOP
        END      

 

          SUBROUTINE DISTCAL(IPR,JNA)
	parameter (nhbond = 5000 )
        DIMENSION XYZ14(3),XYZ15(3),XYZ16(3),XYZ23(3),
     1            XYZ24(3),XYZ25(3),XYZ26(3),XYZ27(3)
        COMMON /NAMES/NAMED(100000),RESD(100000),
     3         NAMEP(100000),RESP(100000)
        COMMON /DATA/XD(100000),YD(100000),ZD(100000),IRESD(100000),
     4         XP(100000),YP(100000),ZP(100000),IRESP(100000),NATD,NATP
        COMMON /CHAINS/CHAINP(100000),CHAIND(100000)
        COMMON /DNA/DIST_DNA(10),NU_DNA(10) 
        COMMON /darr/darp(nhbond,4),darb(nhbond,7)
        COMMON /dchr/dp(nhbond),db(nhbond)
        COMMON /dnt/ndp(nhbond,2),ndb(nhbond,2)
        COMMON /cnt/pcnd,bcnd
        COMMON /dst/hbdst,hvdst,hbang,pro2pro,nchain
        CHARACTER*3 AA,NAMEP,NAMED,RESP,RESD
        CHARACTER*1 CHAINP,CHAIND,NUCL
        CHARACTER*4 RESDH
        CHARACTER*4 dp,db
        integer pcnd,bcnd,pro2pro
          JNA=0 
          DO L=1,NATD
           IF(RESD(L)(1:1).NE.'C'.AND.RESD(L)
     1     .NE.'P  '.and.resd(l)(1:1).ne.'H') THEN
           DX=(XP(IPR)-XD(L))*(XP(IPR)-XD(L))
           DY=(YP(IPR)-YD(L))*(YP(IPR)-YD(L))
           DZ=(ZP(IPR)-ZD(L))*(ZP(IPR)-ZD(L))
           D=(DX+DY+DZ)
           DIST=SQRT(D)
           IF(DIST.LE.hvdst) THEN
C
C  Fixing hydrogens to 2-amino group of GUANINE
C
           IF(RESD(L).EQ.'N2 '.AND.(NAMED(L).EQ.' G '.or.named(L).
     1                   eq.'DG ')) THEN
              NN2 = L
              NRD = IRESD(L)
              DO LL=L-30,L+30
                IF(RESD(LL).EQ.'C2 '.AND.IRESD(LL).EQ.NRD) NC2 = LL
                IF(RESD(LL).EQ.'N3 '.AND.IRESD(LL).EQ.NRD) NN3 = LL
              END DO
              BL=1.0 
	      BANG=121.5 
              RESDH=' H21'
                 bestang=0.0
              DO TANG=-30,30,2 
                CALL FIXATM(NN3,NC2,NN2,BANG,TANG,BL,XYZ14,1)
                CALL ANGDISDNA(IPR,XYZ14,L,1.0,DISDNA,ANGLE)
	         if(angle.gt.bestang) then
                   if(disdna.ge.1.6)then
	            bestang=angle
	            bestdst=disdna
	            besttng=tang
                    dbx=xyz14(1)
                    dby=xyz14(2)
                    dbz=xyz14(3)
                   endif
	          endif
                  if (tang.eq.0.0)then
  	if((disdna.le.hbdst).and.(disdna.ge.1.6).and.(angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                    
          endif
                  end if
              END DO
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
              RESDH=' H22'
                 bestang=0.0
              DO TANG=150,210,2
                CALL FIXATM(NN3,NC2,NN2,BANG,TANG,BL,XYZ25,1)
                CALL ANGDISDNA(IPR,XYZ25,L,1.0,DISDNA,ANGLE)
	         if(angle.gt.bestang) then
                   if(disdna.ge.1.6)then
	            bestang=angle
	            bestdst=disdna
	            besttng=tang
                    dbx=xyz25(1)
                    dby=xyz25(2)
                    dbz=xyz25(3)
                   endif
	          endif
                  if (tang.eq.180.0)then
	if((disdna.le.hbdst).and.(disdna.ge.1.6).and.(angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                     endif
                  end if
              END DO  
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
C
C  Fixing secondary amino hydrogen at N1 position of GUANINE
C
C   Present understanding from QM study indicate this hydrogen does not
C   have capability to adopt non-planarity
C    NOTE: Sudipta, change these; bhatta
           ELSEIF (RESD(L).EQ.'N1 ' .AND.(NAMED(L).EQ.' G '.or.named(L)
     1                .eq.'DG ')) THEN
             NN1 = l
             NRD = iresd(l)
             do ll = l-30,l+30     !  0 is only possible
               if(resd(ll).eq.'C2 '.and.iresd(ll).eq.nrd) NC2 = ll
               IF(RESD(LL).EQ.'N3 '.AND.IRESD(LL).EQ.NRD) NN3 = LL
             END DO
             BL=1.01 
             BANG=117.0 
             RESDH=' H1 '
                bestang=0.0
             DO TANG=150,210,2    ! 180 is only possible
                CALL FIXATM(NN3,NC2,NN1,BANG,TANG,BL,XYZ26,1)
                CALL ANGDISDNA(IPR,XYZ26,L,1.0,DISDNA,ANGLE)
         if(angle.gt.bestang) then
                  if(disdna.ge.1.6)then
            bestang=angle
            bestdst=disdna
            besttng=tang
                   dbx=xyz26(1)
                   dby=xyz26(2)
                   dbz=xyz26(3)
                  endif
          endif
                 if (tang.eq.180.0)then
        if((disdna.le.hbdst).and.(disdna.ge.1.6).and.
     1               (angle.gt.hbang))then
             pcnd=pcnd+1
             darp(pcnd,1)=dist 
             darp(pcnd,2)=disdna     
             darp(pcnd,3)=angle     
             darp(pcnd,4)=tang     
             dp(pcnd)=resdh
             ndp(pcnd,1)=l
             ndp(pcnd,2)=ipr        
                    endif
                 end if
             END DO
             if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
             bcnd=bcnd+1
             darb(bcnd,1)=dist 
             darb(bcnd,2)=bestdst
             darb(bcnd,3)=bestang
             darb(bcnd,4)=besttng
             darb(bcnd,5)=dbx  
             darb(bcnd,6)=dby  
             darb(bcnd,7)=dbz  
             db(bcnd)=resdh
             ndb(bcnd,1)=l
             ndb(bcnd,2)=ipr       
             endif
10        FORMAT('ATOM',8X,A4,1X,A3,1X,A1,1X,I3,4X,3F8.3)         
12        FORMAT(f8.3,4x,A4,2X,A3,1X,A3,1X,A1,1X,I3,2X,A3,1X,A3,1X,A1,
     1           1x,i3,2x,F8.3,4X,F10.3,4X,F5.1) 
C  
C   Fixing hydrogen to N3 position of THYMINE
C
C   Present understanding from QM study indicate this hydrogen does not
C   have capability to adopt non-planarity
C    NOTE: Sudipta, change these; bhatta
C
         ELSE IF(RESD(L).EQ.'N3 '.AND.(NAMED(L).EQ.' T '.or.named(L).
     1             eq.'DT '.or.named(L).eq.' U ')) THEN
             NN3 = L
             NRD = IRESD(L)
             DO LL=L-30,L+30     !  0 is only possible
               IF(RESD(LL).EQ.'C2 '.AND.IRESD(LL).EQ.NRD) NC2 = LL
               IF(RESD(LL).EQ.'N1 '.AND.IRESD(LL).EQ.NRD) NN1 = LL
             END DO
             BL=1.01 
             BANG=115.4 
             RESDH=' H3 '
                bestang=0.0
             DO TANG=150,210,2   ! 180 is only possible
               CALL FIXATM(NN1,NC2,NN3,BANG,TANG,BL,XYZ27,1)
               CALL ANGDISDNA(IPR,XYZ27,L,1.0,DISDNA,ANGLE)
               if(angle.gt.bestang) then
                  if(disdna.ge.1.6)then
            bestang=angle
            bestdst=disdna
            besttng=tang
                   dbx=xyz27(1)
                   dby=xyz27(2)
                   dbz=xyz27(3)
                  endif
               endif
                 if (tang.eq.180.0)then
        if((disdna.le.hbdst).and.(disdna.ge.1.6).and.
     1           (angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                     endif
                  end if
              END DO
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
C
C  Fixing hydrogens to N4-amino group of CYTOSINE
C
      ELSE IF(RESD(L).EQ.'N4 '.AND.NAMED(L).EQ.' C ') THEN
              NN4 = L
              NRD = IRESD(L)
              DO LL=L-30,L+30
                IF(RESD(LL).EQ.'C4 '.AND.IRESD(LL).EQ.NRD) NC4 = LL
                IF(RESD(LL).EQ.'N3 '.AND.IRESD(LL).EQ.NRD) NN3 = LL
              END DO
              BL=1.0 
	      BANG=121.5
              RESDH=' H41'
                 bestang=0.0
              DO TANG=-30,30,2 
                CALL FIXATM(NN3,NC4,NN4,BANG,TANG,BL,XYZ15,1)
                CALL ANGDISDNA(IPR,XYZ15,L,1.0,DISDNA,ANGLE)
	         if(angle.gt.bestang) then
                   if(disdna.ge.1.6)then
	            bestang=angle
	            bestdst=disdna
	            besttng=tang
                    dbx=xyz15(1)
                    dby=xyz15(2)
                    dbz=xyz15(3)
                   endif
	          endif
                  if (tang.eq.0.0)then
	if((disdna.le.hbdst).and.(disdna.ge.1.6).and.(angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                     endif
                  end if
              END DO
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
              RESDH=' H42'
                 bestang=0.0
              DO TANG=150,210,2
                CALL FIXATM(NN3,NC4,NN4,BANG,TANG,BL,XYZ24,1)
                CALL ANGDISDNA(IPR,XYZ24,L,1.0,DISDNA,ANGLE)
	         if(angle.gt.bestang) then
                   if(disdna.ge.1.6)then
	            bestang=angle
	            bestdst=disdna
	            besttng=tang
                    dbx=xyz24(1)
                    dby=xyz24(2)
                    dbz=xyz24(3)
                   endif
	          endif
                  if (tang.eq.180.0)then
	if((disdna.le.hbdst).and.(disdna.ge.1.6).and.(angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                     endif
                  end if
              END DO
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
C
C  Fixing hydrogens to N6-amino group of ADENINE
C
            ELSE IF(RESD(L).EQ.'N6 '.AND.(NAMED(L).EQ.' A '.or.named(L).
     1               eq.'DA ')) THEN
              NN6 = L
              NRD = IRESD(L)
              DO LL=L-30,L+30
                 IF(RESD(LL).EQ.'C6 '.AND.IRESD(LL).EQ.NRD) NC6 = LL
                 IF(RESD(LL).EQ.'C5 '.AND.IRESD(LL).EQ.NRD) NC5 = LL
              END DO
              BL=1.0 
	      BANG=121.5
              RESDH=' H61'   
                 bestang=0.0
              DO TANG=-30,30,2 
                 CALL FIXATM(NC5,NC6,NN6,BANG,TANG,BL,XYZ16,1)
                 CALL ANGDISDNA(IPR,XYZ16,L,1.0,DISDNA,ANGLE)
	         if(angle.gt.bestang) then
                   if(disdna.ge.1.6)then
	            bestang=angle
	            bestdst=disdna
	            besttng=tang
                    dbx=xyz16(1)
                    dby=xyz16(2)
                    dbz=xyz16(3)
                   endif
	          endif
                  if (tang.eq.0.0)then
	if((disdna.le.hbdst).and.(disdna.ge.1.6).and.(angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                     endif
                  end if
              END DO 
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
              RESDH=' H62'
                 bestang=0.0
              DO TANG=150,210,2   
                 CALL FIXATM(NC5,NC6,NN6,BANG,TANG,BL,XYZ23,1)
                 CALL ANGDISDNA(IPR,XYZ23,L,1.0,DISDNA,ANGLE)
	         if(angle.gt.bestang) then
                   if(disdna.ge.1.6)then
	            bestang=angle
	            bestdst=disdna
	            besttng=tang
                    dbx=xyz23(1)
                    dby=xyz23(2)
                    dbz=xyz23(3)
                   endif
	          endif
                  if (tang.eq.180.0)then
	if((disdna.le.hbdst).and.(disdna.ge.1.6).and.(angle.gt.hbang))then
              pcnd=pcnd+1
              darp(pcnd,1)=dist 
              darp(pcnd,2)=disdna     
              darp(pcnd,3)=angle     
              darp(pcnd,4)=tang     
              dp(pcnd)=resdh
              ndp(pcnd,1)=l
              ndp(pcnd,2)=ipr        
                      endif
                  end if
              END DO
              if((bestdst.le.hbdst).and.(bestang.gt.hbang))then
              bcnd=bcnd+1
              darb(bcnd,1)=dist 
              darb(bcnd,2)=bestdst
              darb(bcnd,3)=bestang
              darb(bcnd,4)=besttng
              darb(bcnd,5)=dbx  
              darb(bcnd,6)=dby  
              darb(bcnd,7)=dbz  
              db(bcnd)=resdh
              ndb(bcnd,1)=l
              ndb(bcnd,2)=ipr       
              endif
	    ELSE
              JNA=JNA+1
              DIST_DNA(JNA)=DIST
              NU_DNA(JNA)=L
            END IF
           END IF
	  endif
          END DO
c            NU_DNA(JNA)=L
c            END IF
c           END IF
c          END DO
7         FORMAT(A4,3F10.5,3X,A3)
9         FORMAT(A4,3F10.5,3X,A3) 
C
C  Calculation of hydrogen bonding between two protein chains follows
C
	if(pro2pro.eq.1.and.nchain.gt.1) then
          DO L=1,NATP
	   IF(CHAINP(L).NE.CHAINP(IPR)) THEN
	     IF(RESp(L)(1:1).eq.'O'.or.resp(l)(1:1).eq.'S'.or.resp(l)
     1   .eq.'ND1'.or.(resp(l).eq.'NE2'.and.namep(l).eq.'HIS')) then
               DX=(XP(IPR)-Xp(L))*(XP(IPR)-Xp(L))
               DY=(YP(IPR)-Yp(L))*(YP(IPR)-Yp(L))
               DZ=(ZP(IPR)-Zp(L))*(ZP(IPR)-Zp(L))
               D=(DX+DY+DZ)
               DIST=SQRT(D)
               IF(DIST.LE.hvdst) THEN
                 JNA=JNA+1
                 DIST_DNA(JNA)=DIST
                 NU_DNA(JNA)=L
c	write(*,*) dist,l,ipr,resp(l),jna
	       ENDIF
	     endif
	   endif
	  enddo
	endif
C
C   Sorting the acceptor positions according to HB distance
C
            DO I=2,JNA
              IF(dist_dna(1).GT.dist_dna(I))THEN
              TMP=dist_dna(I)
              dist_dna(I)=dist_dna(1)
              dist_dna(1)=TMP
              NTMP=nu_dna(I)
              nu_dna(I)=nu_dna(1)
              nu_dna(1)=NTMP
              end if
            END DO
C
          RETURN
          END

       SUBROUTINE ANGDISPRO(JNA,XYZ,I,BL,DISPRO,ANGLE)       
c        COMMON /NAMES/NAMED(100000),RESD(100000),
c     3          NAMEP(100000),RESP(100000)
       COMMON /CHAINS/CHAINP(100000),CHAIND(100000)
        COMMON /DNA/DIST_DNA(10),NU_DNA(10)
        COMMON /dst/hbdst,hvdst,hbang,pro2pro,nchain
        COMMON /DATA/XD(100000),YD(100000),ZD(100000),IRESD(100000),
     4         XP(100000),YP(100000),ZP(100000),IRESP(100000),NATD,NATP
	character*1 chaind,chainp
        CHARACTER*3 AA,NAMEP,NAMED,RESP,RESD
	integer pro2pro
        DIMENSION X1(3),X2(3),X3(3),XYZ(3),DISPRO(10),ANGLE(10)
           DO M=1,JNA
              ND=NU_DNA(M)
              DX=(XD(ND)-XYZ(1))*(XD(ND)-XYZ(1))
              DY=(YD(ND)-XYZ(2))*(YD(ND)-XYZ(2))
              DZ=(ZD(ND)-XYZ(3))*(ZD(ND)-XYZ(3))
              D=(DX+DY+DZ)
              DISPRO(M)=SQRT(D)    
              ANGLE1= ((XP(I)-XYZ(1))*(XD(ND)-XYZ(1))+
     1                  (YP(I)-XYZ(2))*(YD(ND)-XYZ(2))+
     2                  (ZP(I)-XYZ(3))*(ZD(ND)-XYZ(3)))/
     3                  (BL*DISPRO(M))
	      ANGLE(M)=ACOSF(ANGLE1)
	    END DO
	if(pro2pro.eq.1.and.nchain.gt.1) then
           DO M=1,JNA
              ND=NU_DNA(M)
              DX=(Xp(ND)-XYZ(1))*(Xp(ND)-XYZ(1))
              DY=(Yp(ND)-XYZ(2))*(Yp(ND)-XYZ(2))
              DZ=(Zp(ND)-XYZ(3))*(Zp(ND)-XYZ(3))
              D=(DX+DY+DZ)
              DISPRO(M)=SQRT(D)    
              ANGLE1= ((XP(I)-XYZ(1))*(Xp(ND)-XYZ(1))+
     1                  (Yp(I)-XYZ(2))*(Yp(ND)-XYZ(2))+
     2                  (Zp(I)-XYZ(3))*(Zp(ND)-XYZ(3)))/
     3                  (BL*DISPRO(M))
	      ANGLE(M)=ACOSF(ANGLE1)
	    END DO
	endif

            RETURN
            END

       SUBROUTINE ANGDISDNA(IPR,XYZ,L,BL,DISDNA,ANGLE)       
        CHARACTER*3 AA,NAMEP,NAMED,RESP,RESD
        COMMON /NAMES/NAMED(100000),RESD(100000),
     3          NAMEP(100000),RESP(100000)
        COMMON /DATA/XD(100000),YD(100000),ZD(100000),IRESD(100000),
     4         XP(100000),YP(100000),ZP(100000),IRESP(100000),NATD,NATP
        DIMENSION X1(3),X2(3),X3(3),XYZ(3)
              DX=(XP(IPR)-XYZ(1))*(XP(IPR)-XYZ(1))
              DY=(YP(IPR)-XYZ(2))*(YP(IPR)-XYZ(2))
              DZ=(ZP(IPR)-XYZ(3))*(ZP(IPR)-XYZ(3))
              D=(DX+DY+DZ)
              DISDNA=SQRT(D)    
              ANGLE1= ((XD(L)-XYZ(1))*(XP(IPR)-XYZ(1))+
     1                  (YD(L)-XYZ(2))*(YP(IPR)-XYZ(2))+
     2                  (ZD(L)-XYZ(3))*(ZP(IPR)-XYZ(3)))/
     3                  (BL*DISDNA)
	      ANGLE=ACOSF(ANGLE1)
              RETURN
              STOP
              END

        SUBROUTINE FIXATM(N1,N2,N3,BA,TA,BL,XYZ,INDEXPR)

        COMMON /DATA/XD(100000),YD(100000),ZD(100000),IRESD(100000),
     4         XP(100000),YP(100000),ZP(100000),IRESP(100000),NATD,NATP
        DIMENSION X1(3),X2(3),X3(3),XYZ(3)
        IF(INDEXPR.EQ.0)THEN
             X3(1)=XP(N3)
             X3(2)=YP(N3)
             X3(3)=ZP(N3)
             X2(1)=XP(N2)
             X2(2)=YP(N2)
             X2(3)=ZP(N2)
             X1(1)=XP(N1)
             X1(2)=YP(N1)
             X1(3)=ZP(N1)
           ELSE
             X1(1)=XD(N1)
             X1(2)=YD(N1)
             X1(3)=ZD(N1)
             X2(1)=XD(N2)
             X2(2)=YD(N2)
             X2(3)=ZD(N2)
             X3(1)=XD(N3)
             X3(2)=YD(N3)
             X3(3)=ZD(N3)
        END IF
        CALL CRS32(X1,X2,X3,BA,TA,BL,xyz)
        RETURN
        END
***********************************************************
        SUBROUTINE COTRAN(R,PHI,X,Y)
	External cosd, SIND
        X=R*COSD(PHI)
           Y=R*SIND(PHI)
        RETURN
        END
***********************************************************
        SUBROUTINE CORTAN(X,Y,R,PHI)
        R=SQRT(X*X+Y*Y)
        IF(ABS(X)-0.0001) 103,104,104
103     CONTINUE
        PHI = 90.0
        IF(Y) 105,999,999
105     CONTINUE
        PHI = -PHI
        GO TO 999
104     CONTINUE
        PHI=ATAN(Y/X)*57.2958
        IF(X)100,999,999
100     CONTINUE
        IF(PHI) 101,102,102
102     CONTINUE
        PHI = PHI-180.
        GO TO 999
101     CONTINUE
        PHI = PHI+180.
999     RETURN
        END
        SUBROUTINE CRS65(R,A1,A2,A3,B)
         DIMENSION B(3),R(3,3)
         DO 100 I=1,3
         B(I) = R(I,1) * A1 + R(I,2) * A2 + R(I,3) * A3
 100  CONTINUE
      RETURN
         END
C
C
      SUBROUTINE CRS77(A1,A2,A3,B)
         DIMENSION B(3)
         FAC = 1.0/SQRTF(A1 * A1 + A2 * A2 + A3 * A3)
         B(1) = A1 * FAC
         B(2) = A2 * FAC
         B(3) = A3 * FAC
         RETURN
         END
C
C
       FUNCTION SQRTF(X)
  1    FORMAT(2X,'SQUARE ROOT OF A NEGATIVE QUANTITY?',E16.8)
       IF(X.LT.0.0) GO TO 101
          SQRTF = SQRT(X)
          RETURN
 101   CONTINUE
          SQRTF = 0.0
          RETURN
          END
       SUBROUTINE CRS63(EL,EM,EN,AG,R)
       DIMENSION R(3,3)
          CONVN = 3.14159/180.0
          ANG = AG * CONVN
          CS = COS(ANG)
          SN = SIN(ANG)
          CSS = 1.0 - CS
          A1 = EL * SN
          A2 = EM * SN
          A3 = EN * SN
          B1 = EM * EN * CSS
          B2 = EN * EL * CSS
          B3 = EL * EM * CSS
          R(1,1) = CS + EL * EL * CSS
          R(2,2) = CS + EM * EM * CSS
          R(3,3) = CS + EN * EN * CSS
          R(1,2) = B3 - A3
          R(2,1) = B3 + A3
          R(3,1) = B2 - A2
          R(1,3) = B2 + A2
          R(2,3) = B1 - A1
          R(3,2) = B1 + A1
          RETURN
          END
       SUBROUTINE CR23A(A1,A2,A3,B1,B2,B3,EL,EM,EN)
       C1 = A2 * B3 - A3 * B2
       C2 = A3 * B1 - A1 * B3
       C3 = A1 * B2 - A2 * B1
       FAC1 = SQRTF(C1 * C1 + C2 * C2 + C3 * C3)
       IF(FAC1.LE.0.00001) GO TO 100
       FAC1 = 1.0/FAC1
 100    CONTINUE
       EL = C1 * FAC1
       EM = C2 * FAC1
       EN = C3 * FAC1
      RETURN
      END
      SUBROUTINE CRS32(X1,X2,X3,TA,CH,AL,X4)
      DIMENSION X1(3),X2(3),X3(3),X4(3),V1(3),V2(3),V4(3),V5(3)
      DIMENSION R(3,3),ALMN1(3),ALMN2(3)
      TAU1 = 180.0 - TA
      DO 1 I=1,3
      V1(I) = X3(I) - X2(I)
      V2(I) = X1(I) - X2(I)
  1   CONTINUE
      CALL CR23A(V1(1),V1(2),V1(3),V2(1),V2(2),V2(3),ALMN1(1),ALMN1(2),
     1ALMN1(3))
      CALL CRS77(V1(1),V1(2),V1(3),ALMN2)
      CALL CRS63(ALMN1(1),ALMN1(2),ALMN1(3),TAU1,R)
      CALL CRS65(R,ALMN2(1),ALMN2(2),ALMN2(3),V4)
      CALL CRS63(ALMN2(1),ALMN2(2),ALMN2(3),CH,R)
      CALL CRS65(R,V4(1),V4(2),V4(3),V5)
      DO 3 I=1,3
      X4(I) = X3(I) + V5(I) * AL
  3   CONTINUE
      RETURN
      END
C
       FUNCTION COSD(X)
          CONV = 3.14159/180.0
          X = X * CONV
          COSD = COS(X)
          RETURN
          END
C
C
       FUNCTION SIND(X)
          CONV = 3.14159/180.0
          X = X * CONV
          SIND = SIN(X)
          RETURN
          END

      SUBROUTINE TORAN(A,B,C,D,CHI)
      DIMENSION A(3),B(3),C(3),D(3)
      DIMENSION WX(3),WY(3),WZ(3),EL(3),EM(3),EN(3)
      DO 100 J = 1,3
      WX(J)=A(J)-B(J)
      WY(J)=C(J)-B(J)
      WZ(J)=D(J)-B(J)
100   CONTINUE
      CALL UNITV(WX(1),WX(2),WX(3),WY(1),WY(2),WY(3),EL(1),EM(1),EN(1))
      CALL UNITV(WZ(1),WZ(2),WZ(3),WY(1),WY(2),WY(3),EL(2),EM(2),EN(2))
      CHI=ACOSF(EL(1)*EL(2)+EM(1)*EM(2)+EN(1)*EN(2))
      CALL UNITV(EL(2),EM(2),EN(2),EL(1),EM(1),EN(1),EL(3),EM(3),EN(3))
      CHECK=EL(3)*WY(1)+EM(3)*WY(2)+EN(3)*WY(3)
      IF(CHECK.LT.0.0) RETURN
      CHI=0.0-CHI
      IF(CHI.GT.180.0) THEN
          CHI = CHI - 360.0
      END IF
      RETURN
      END
C 
C***********************************************************************
C 
      SUBROUTINE UNITV(A1,A2,A3,B1,B2,B3,EL,EM,EN)
      C1 = A2*B3-A3*B2
      C2 = A3*B1-A1*B3
      C3 = A1*B2-A2*B1
      FAC = 0.0
      FAC1 =SQRTF(C1*C1+C2*C2+C3*C3)
      IF(FAC1.LE.0.00001) GO TO 100
      FAC = 1.0/FAC1
100   CONTINUE
      EL =C1*FAC
      EM =C2*FAC
      EN =C3*FAC
      RETURN
      END
C
      FUNCTION ACOSF(ANG)
1     FORMAT('  Cos (Theta) is greater than 1 !',F12.8)
      IF (ABS(ANG).LT.1.000001) GO TO 102
      ACOSF=0.0
      IF (ANG.LT.0.0) ACOSF = 180.0
	write(6,1)
      RETURN
102   CONTINUE
      ACOSF=ACOS(ANG)*180.0/3.14159265
      RETURN
      END
C *********************************************************************
C
 
 	subroutine bestfind(angle,dispro,jna,xyz,bestang,
     1                  bestdst,besttng,
     1                      tang,pbx,pby,pbz)
	dimension xyz(3),angle(10),bestang(10),bestdst(10),besttng(10),
     1         plndst(10),plnang(10),dispro(10),pbx(10),pby(10),pbz(10)
C     
C Storing the best set of hydrogen bonds with non planar (or planar) amino group
C
	do kk=1,jna
	  if(angle(kk).gt.bestang(kk)) then
             if(dispro(kk).ge.1.6)then
	       bestang(kk)=angle(kk)
	       bestdst(kk)=dispro(kk)
	       besttng(kk)=tang
               pbx(kk)=xyz(1)
               pby(kk)=xyz(2)
               pbz(kk)=xyz(3)
             endif  
	  endif
	enddo
	return
	end
